ВидеоКонф(ВКС)  ::   Чат  ::   FAQ  ::   Поиск  ::   Регистрация  ::   Вход

Asterisk не компилируется с флагом --with-avcodec

Проблемы и их решения Asterisk как такового

Модератор: april22

Asterisk не компилируется с флагом --with-avcodec

Сообщение central » 21 июн 2022, 22:38

Пробую прикрутить avcodec (Ubuntu server 22.04) различными методами, и, установкой из репозитория ubuntu и сборкой из исходных файлов и заменой некоторых его модулей на extra и снова возвращаясь к стандартной установке.
Ниже приведён результат моей последней установки из исходных файлов в точном соответствии с официальным мануалом:
https://trac.ffmpeg.org/wiki/CompilationGuide/Ubuntu
Мануал наикрутейший, претензий к нему нет, всё работает...
Командой ffmpeg вижу выхлоп:
ffmpeg version N-107160-gaa1babc59a Copyright (c) 2000-2022 the FFmpeg developers
built with gcc 11 (Ubuntu 11.2.0-19ubuntu1)
configuration: --prefix=/home/mvt/ffmpeg_build --pkg-config-flags=--static --extra-cflags=-I/home/mvt/ffmpeg_build/include --extra-ldflags=-L/home/mvt/ffmpeg_build/lib --extra-libs='-lpthread -lm' --ld=g++ --bindir=/home/mvt/bin --enable-gpl --enable-gnutls --enable-libaom --enable-libass --enable-libfdk-aac --enable-libfreetype --enable-libmp3lame --enable-libopus --enable-libsvtav1 --enable-libdav1d --enable-libvorbis --enable-libvpx --enable-libx264 --enable-libx265 --enable-nonfree
libavutil 57. 27.100 / 57. 27.100
libavcodec 59. 33.100 / 59. 33.100
libavformat 59. 25.100 / 59. 25.100
libavdevice 59. 6.100 / 59. 6.100
libavfilter 8. 41.100 / 8. 41.100
libswscale 6. 6.100 / 6. 6.100
libswresample 4. 6.100 / 4. 6.100
libpostproc 56. 5.100 / 56. 5.100

Hyper fast Audio and Video encoder
usage: ffmpeg [options] [[infile options] -i infile]... {[outfile options] outfile}...

Use -h to get full help or, even better, run 'man ffmpeg'

Вроде всё хорошо, но asterisk отказывается компилироваться.
В /usr/local/bin исполняемый файл ffmpeg есть и доступен всем пользователям.

В процессе компиляции с различными флагами asterisk спотыкается на этом флаге, можно собрать и без него, но хотелось бы собрать с ним, а как это побороть... я в замешательстве.

Вот что говорит asterisk:
checking for bridges/bridge_softmix/include/hrirs.h... yes
checking for mandatory modules: CRYPTO OPENSSL JANSSON PJPROJECT ALSA BLUETOOTH DAHDI FFMPEG GSM ILBC ICONV IKSEMEL IMAP_TK JACK JANSSON LDAP LIBXML2 NEON NEON29 OGG OPUS PGSQL PORTAUDIO PRI RADIUS SPEEX SPEEX_PREPROCESS SPEEXDSP SRTP TONEZONE UNIXODBC VORBIS VPB ZLIB... fail

configure: ***
configure: *** The FFMPEG installation appears to be missing or broken.
configure: *** Either correct the installation, or run configure
configure: *** including --without-avcodec.

И, такими выхлопами наводнён интернет, а реального ответа, ну, я не нашёл.
Может есть какие мысли???
central
 
Сообщений: 10
Зарегистрирован: 19 июн 2022, 17:40

Re: Asterisk не компилируется с флагом --with-avcodec

Сообщение ded » 22 июн 2022, 04:36

Для сборки Астериск с поддержкой avcodec исполняемого файла ffmpeg мало. Надо что-то типа libffmpeg-dev, ffmpeg-dev пакетов, где хидеры для сборки.
ded
 
Сообщений: 15312
Зарегистрирован: 26 авг 2010, 19:00

Re: Asterisk не компилируется с флагом --with-avcodec

Сообщение central » 22 июн 2022, 07:46

В пылу борьбы забыл сообщить, что и эти манипуляции я тоже совершал, вот, что имеется:

asterisk-18.12.1$ sudo apt search ffmpeg-dev
Сортировка... Done
Полнотекстовый поиск... Done

asterisk-18.12.1$ sudo apt search libffmpeg
Сортировка... Done
Полнотекстовый поиск... Done
libffmpeg-nvenc-dev/jammy 11.1.5.1-1 all
FFmpeg headers for interfacing with NVIDIA's codec APIs

libffmpeg-ocaml/jammy 1.1.1-1build1 amd64
OCaml interface for FFmpeg -- runtime files

libffmpeg-ocaml-dev/jammy 1.1.1-1build1 amd64
OCaml interface for FFmpeg -- development files

libffmpegthumbnailer-dev/jammy 2.2.2+dfsg-1 amd64
development files for ffmpegthumbnailer

libffmpegthumbnailer4v5/jammy 2.2.2+dfsg-1 amd64
shared library for ffmpegthumbnailer

Для того чтобы проверить всё и сразу выберем всё и сразу:

sudo apt install libffmpeg-nvenc-dev libffmpeg-ocaml-dev libffmpegthumbnailer-dev
Reading package lists... Done
Building dependency tree... Done
Reading state information... Done
Будут установлены следующие дополнительные пакеты:
libaacs0 libavc1394-0 libavcodec-dev libavcodec58 libavdevice-dev libavdevice58 libavfilter-dev libavfilter7 libavformat-dev
libavformat58 libavutil-dev libavutil56 libbdplus0 libblas3 libbluray2 libbs2b0 libcaca0 libcdio-cdda2 libcdio-paranoia2 libcdio19
libchromaprint1 libcodec2-1.0 libdc1394-25 libffmpeg-ocaml libffmpegthumbnailer4v5 libflite1 libgfortran5 libgme0 libiec61883-0
liblapack3 liblilv-0-0 libmfx1 libmpg123-0 libmysofa1 libnorm1 libopenal-data libopenal1 libopenjp2-7 libopenmpt0 libpgm-5.3-0
libpocketsphinx3 libpostproc-dev libpostproc55 librabbitmq4 libraw1394-11 librubberband2 libsamplerate0 libserd-0-0 libshine3
libsnappy1v5 libsord-0-0 libsoxr0 libspeex1 libsphinxbase3 libsratom-0-0 libsrt1.4-gnutls libssh-gcrypt-4 libswresample-dev
libswresample3 libswscale-dev libswscale5 libtheora0 libtwolame0 libudfread0 libvidstab1.1 libvpx7 libwebpmux3 libx264-163
libx265-199 libxvidcore4 libzimg2 libzmq5 libzvbi-common libzvbi0 ocl-icd-libopencl1 pocketsphinx-en-us

И, результат:

asterisk-18.12.1$ sudo ./configure --prefix=/usr --sysconfdir=/etc --localstatedir=/var --libdir=/usr/lib64 --with-dahdi --with-pri --with-iconv --with-libcurl --with-speex --with-postgres --with-unixodbc --with-speexdsp --with-pjproject --with-neon --with-ldap --with-jansson --with-gsm --with-jansson-bundled --with-pjproject-bundled --with-imap --with-z --with-vpb --with-vorbis --with-portaudio --with-asound --with-neon29 --with-ogg --with-opus --with-bluetooth --with-ssl --with-crypto --with-tonezone --with-libxml2 --with-radius --with-ilbc --with-jack --with-srtp --with-iksemel --with-libxml2 --without-x11 --with-avcodec

checking for mandatory modules: CRYPTO OPENSSL JANSSON PJPROJECT ALSA BLUETOOTH DAHDI FFMPEG GSM ILBC ICONV IKSEMEL IMAP_TK JACK JANSSON LDAP LIBXML2 NEON NEON29 OGG OPUS PGSQL PORTAUDIO PRI RADIUS SPEEX SPEEX_PREPROCESS SPEEXDSP SRTP TONEZONE UNIXODBC VORBIS VPB ZLIB... fail

configure: ***
configure: *** The FFMPEG installation appears to be missing or broken.
configure: *** Either correct the installation, or run configure
configure: *** including --without-avcodec.

А, больше никаких пакетов с хидерами для сборки Ubuntu 22.04 по такой команде не находит...

Ну, как-бы ещё что-то есть если смотреть огромный список по sudo apt search ffmpeg, например:
sudo apt install libavcodec-dev
Но, это тоже ничего не даёт, asterisk не собирается...
central
 
Сообщений: 10
Зарегистрирован: 19 июн 2022, 17:40

Re: Asterisk не компилируется с флагом --with-avcodec

Сообщение ded » 22 июн 2022, 15:36

Скрипт configure проверяет на основе содержимого трёх переменных: FFMPEG_DIR,FFMPEG_INCLUDE, И FFMPEG_LIB делает проверку наличия его в системе. Если найдено, то
AST_FFMPEG_FOUND=yes
Если какая-то пуста -
AST_FFMPEG_FOUND=no
и выводится сообщение
configure: *** The FFMPEG installation appears to be missing or broken.

Так что изучайте код, какие зависимости он анализирует.
ded
 
Сообщений: 15312
Зарегистрирован: 26 авг 2010, 19:00

Re: Asterisk не компилируется с флагом --with-avcodec

Сообщение central » 22 июн 2022, 20:05

Сразу всё стало понятно.
Если в том, что Вы делаете и заключается вся помощь в этом форуме, то мне очень жаль.
Я не просил Вас навязывать мне свою бизнес-модель в личном сообщении.
Не хотите предельно четко пояснить чего я делаю не так, не надо.
И, заметьте, это не обида, а, так, замечание к Вам как, пусть и, модератору.
Не думаю, что Вы знаете то, что знаю я, и то, что Вы в моих возмездных услугах не нуждаетесь ещё не даёт Вам право "выбивать" из меня деньги.
Помощь дело добровольное как и просьба об оказании таких услуг.
Если так, то я бы сразу с раздел бизнес и написал.
central
 
Сообщений: 10
Зарегистрирован: 19 июн 2022, 17:40

Re: Asterisk не компилируется с флагом --with-avcodec

Сообщение Zavr2008 » 22 июн 2022, 20:24

Не хотите предельно четко пояснить чего я делаю не так, не надо.

Тут ребята делятся тем как решать проблемы, никто Вам ничего не должен: пояснять, учить или растолковывать..
Вам выше же написали путь решения, нужно затратить дальше собственную энергию либо воспользоваться помощью что уважаемый ded наверное и предложил.
Очень печально когда закипают чайники, не умеют сами пересобирать пакеты, не читают инструкции и еще умудряются со всеми переругаться..
Российские шлюзы E1 Alvis-GW. Voip-Модернизация УПАТС, FreePBX, CRM. Продолжаем работать, импортозамещаем!
Аватар пользователя
Zavr2008
 
Сообщений: 1970
Зарегистрирован: 27 янв 2011, 01:35

Re: Asterisk не компилируется с флагом --with-avcodec

Сообщение central » 22 июн 2022, 20:57

Я бы не стал обзываться определением типа "чайники".
Если дед уважаемый, я чайник, Вы, видимо, бог asteriskа, ну так сделайте форум закрытым, для своих и радуйте самих себя.
А, потом, если это нормально, ну, так написал бы дед открыто, что он хочет денег, я бы всё понял.
А, это что?
Я ни с кем не ругался и с самого начала предельно вежлив, абсолютно со всеми.
Какую конкретно я инструкцию не прочитал?
Я так понимаю, если у меня ни на одной системе ubuntu обсуждаемый флаг ни разу не отработал, то наверное это проблема не только у меня, и, если это не так, так я и спросил, что я делаю не так.
В общем, я, пусть, по-вашему и чайник, однако смог самостоятельно настроить и динамическую маршрутизацию и cdr с postgresql, в конце концов собрать астериск со всеми возможными библиотеками самостоятельно разобравшись в том числе и с компилятором, выдаваемыми им ошибками при сборке и тд. и тп, транспортами tls ssl шифрованием, может это для вас не достижение, ну уж точно не уровень чайник.
Так, что я никого не принуждаю мне нарисовать лёгкий путь, а всего лишь просил отнестись по-человечески, а не задирать нос.
central
 
Сообщений: 10
Зарегистрирован: 19 июн 2022, 17:40

Re: Asterisk не компилируется с флагом --with-avcodec

Сообщение Zavr2008 » 22 июн 2022, 21:11

именно чайник, закипающий, причем еще и невежественный. Обычно это определяется сейчас сборкой под Ubuntu 22, Asterisk 18 (странно что не 19), только хардкор только победа. Сидим значит и по статье какой на хабре строка за строкой тыкаем. Разум иногда нужно включать, не дерзить старшим и слушать советы. Также проявлять уважение в общении и вообще соблюдать правила данного ресурса, они подтверждаются при регистрации..

и не Вам затыкать рот - форум открытый и помогает тысячам человек. Не Вам решать Слава Богу это.
Российские шлюзы E1 Alvis-GW. Voip-Модернизация УПАТС, FreePBX, CRM. Продолжаем работать, импортозамещаем!
Аватар пользователя
Zavr2008
 
Сообщений: 1970
Зарегистрирован: 27 янв 2011, 01:35

Re: Asterisk не компилируется с флагом --with-avcodec

Сообщение central » 22 июн 2022, 21:25

Вот только не следует заниматься моим унижением, есть что сказать по делу говорите, нет, так нет. Требовать уважения одновременно заявляя о своем превосходстве?
И, если что бога нет, это фэйки.
И, если я правила форума нарушил, то потрудитесь назвать какие конкретно.
Чего лично вас не устраивает в моем выборе, я не могу поставить 18 версию asterisk?
Я не имею права установить ubuntu 22.04, я не должен ставить БД?
Так как вы пытаетесь меня унизить так бы вы с таким остервенением попытались бы понять что я делаю не так, а то чем вы сейчас занимаетесь это чистая деструктивная деятельность.
Да, я изучаю конфигурационный скрипт, на который указал дед, а вы, что родились и вас бог asteriska подарил вам мешок своих знаний???
Облить грязью другого большого ума не надо, даже если вы знаете больше меня в определённой сфере.
central
 
Сообщений: 10
Зарегистрирован: 19 июн 2022, 17:40

Re: Asterisk не компилируется с флагом --with-avcodec

Сообщение Zavr2008 » 22 июн 2022, 21:58

Не льстите себе, не удалось тут закидать шапками про srtp и прочее - видали мы тут чайников и более пламенных)

А то что ни один уважающий себя астерискер не поставит в прод только что выпеченные релизы это факт. Это и по убунте (Ubuntu 22.04 was released on April 21, 2022), и по Asterisk 18(2020-10-20, вроде уже 2 года но обычно мы тут все как минимум 3 года ждем), да и по остальным вопросам сразу видно нет опыта - например нет элементарных умений вместо качева с репы того же ffmpeg с либами варианта make/make install )
Для прода берется уже устоявшееся все, проверенное и работающее.
К тому же Будущее Телефонии читать стоит прежде чем вопить. В новых редакциях и про сборку Вашего вопроса расписано. Но надо же "..предельно четко пояснить чего я делаю не так, не надо. "

что родились и вас бог asteriska подарил вам мешок своих знаний

Отнюдь, на этом же ресурсе есть мои посты ранние. Никогда я не позволял себе так вести себя с остальными, никогда.
Чести не делает.
Российские шлюзы E1 Alvis-GW. Voip-Модернизация УПАТС, FreePBX, CRM. Продолжаем работать, импортозамещаем!
Аватар пользователя
Zavr2008
 
Сообщений: 1970
Зарегистрирован: 27 янв 2011, 01:35

След.

Вернуться в Конфигурация и настройка Asterisk

Кто сейчас на форуме

Сейчас этот форум просматривают: нет зарегистрированных пользователей и гости: 9

© 2008 — 2022 Asterisk.ru
Digium, Asterisk and AsteriskNOW are registered trademarks of Digium, Inc.
Design and development by PostMet-Netzwerk GmbH